<?php

include_once("ver_model.php");

class Da_ver_package extends Ver_model {		
	
	// PK is pkg_id
	
	public $pkg_id;
	public $pkg_sys_id;
	public $pkg_upload_date;
	public $pkg_download_date;
	public $pkg_update_date;
	public $pkg_version;
	public $pkg_name;
	public $pkg_text_en;
	public $pkg_detail;
	public $pkg_by;
	public $pkg_download_status;
	public $pkg_update_status;

	public $last_insert_id;

	function Da_ver_package() {
		parent::__construct();
	}
	
	function insert() {
		// if there is no auto_increment field, please remove it
		$sql = "INSERT INTO ".$this->ver_db.".ver_package (pkg_id, pkg_sys_id, pkg_upload_date, pkg_download_date, pkg_update_date, pkg_version, pkg_name, pkg_text_en, pkg_detail, pkg_by, pkg_download_status, pkg_update_status)
				VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
		$this->db->query($sql, array($this->pkg_id, $this->pkg_sys_id, $this->pkg_upload_date, $this->pkg_download_date, $this->pkg_update_date, $this->pkg_version, $this->pkg_name, $this->pkg_text_en, $this->pkg_detail, $this->pkg_by, $this->pkg_download_status, $this->pkg_update_status));
		$this->last_insert_id = $this->db->insert_id();
	}
	
	function update() {
		// if there is no primary key, please remove WHERE clause.
		$sql = "UPDATE ".$this->ver_db.".ver_package 
				SET	pkg_sys_id=?, pkg_upload_date=?, pkg_download_date=?, pkg_update_date=?, pkg_version=?, pkg_name=?, pkg_text_en=?, pkg_detail=?, pkg_by=?, pkg_download_status=?, pkg_update_status=? 
				WHERE pkg_id=?";	
		$this->db->query($sql, array($this->pkg_sys_id, $this->pkg_upload_date, $this->pkg_download_date, $this->pkg_update_date, $this->pkg_version, $this->pkg_name, $this->pkg_text_en, $this->pkg_detail, $this->pkg_by, $this->pkg_download_status, $this->pkg_update_status, $this->pkg_id));	
	}
	
	function delete() {
		// if there is no primary key, please remove WHERE clause.
		$sql = "DELETE FROM ".$this->ver_db.".ver_package
				WHERE pkg_id=?";
		$this->db->query($sql, array($this->pkg_id));
	}
	
	/*
	 * You have to assign primary key value before call this function.
	 */
	function get_by_key($withSetAttributeValue=FALSE) {	
		$sql = "SELECT * 
				FROM ".$this->ver_db.".ver_package 
				WHERE pkg_id=?";
		$query = $this->db->query($sql, array($this->pkg_id));
		if ( $withSetAttributeValue ) {
			$this->row2attribute( $query->row() );
		} else {
			return $query ;
		}
	}
	
}	 //=== end class Da_ver_package
?>