<?php

include_once("da_ver_file.php");

class M_ver_file extends Da_ver_file {

	/*
	 * aOrderBy = array('fieldname' => 'ASC|DESC', ... )
	 */
	function get_all($aOrderBy=""){
		$orderBy = "";
		if ( is_array($aOrderBy) ) {
			$orderBy.= "ORDER BY "; 
			foreach ($aOrderBy as $key => $value) {
				$orderBy.= "$key $value, ";
			}
			$orderBy = substr($orderBy, 0, strlen($orderBy)-2);
		}
		$sql = "SELECT * 
				FROM ".$this->ver_db.".ver_file 
				$orderBy";
		$query = $this->db->query($sql);
		return $query;
	}
	
	/*
	 * create array of pk field and value for generate select list in view, must edit PK_FIELD and FIELD_NAME manually
	 * the first line of select list is '-----เลือก-----' by default.
	 * if you do not need the first list of select list is '-----เลือก-----', please pass $optional parameter to other values. 
	 * you can delete this function if it not necessary.
	 */
	function get_options($optional='y') {
		$qry = $this->get_all();
		if ($optional=='y') $opt[''] = '-----เลือก-----';
		foreach ($qry->result() as $row) {
			$opt[$row->PK_FIELD] = $row->FIELD_NAME;
		}
		return $opt;
	}
	
	// add your functions here
	function get_byPkgId($id) {
		$sql = "SELECT * FROM ".$this->ver_db.".ver_file 
				WHERE file_pkg_id = ?";
		$query = $this->db->query($sql, array($id));
		return $query;
	}
	
	function get_filedownload() {
		$sql = "SELECT * FROM ".$this->ver_db.".ver_file 
				LEFT JOIN ".$this->ver_db.".ver_package ON file_pkg_id = pkg_id
				LEFT JOIN ".$this->ver_db.".ver_client_system ON pkg_sys_id = csys_id
				WHERE pkg_download_status = '2' AND pkg_update_status = 'N'";
		$query = $this->db->query($sql);
		return $query;
	}
	
	function get_filebyPkgIdJoin($id) {
		$sql = "SELECT * FROM ".$this->ver_db.".ver_file 
				LEFT JOIN ".$this->ver_db.".ver_package ON file_pkg_id = pkg_id
				LEFT JOIN ".$this->ver_db.".ver_client_system ON pkg_sys_id = csys_id
				WHERE file_pkg_id = ?";
		$query = $this->db->query($sql, array($id));
		return $query;
	}
	
	function update_upd_status($file_update_status, $pkg_id){
		$sql = "UPDATE ".$this->ver_db.".ver_file 
				SET	file_update_status=?
				WHERE file_pkg_id=?";	
		$this->db->query($sql, array($file_update_status, $pkg_id));	
	}
	
} // end class M_ver_file
?>